<template>
  <div
    class="message-card-container"
    :class="{
      'current-user': senderMessageId == currentUser,
      'notif-message-container': notifHandler,
    }"
  >
    <div
      class="avatar-container"
      :class="{
        'display-none': senderMessageId == currentUser,
        'visibility-none': detectAvatarFlag,
      }"
    >
      <div
        class="avatar"
        v-if="
          messageTypeHandler == 'txt' ||
          messageTypeHandler == 'img' ||
          messageTypeHandler == 'aud' ||
          messageTypeHandler == 'stk' ||
          messageTypeHandler == 'doc' ||
          messageTypeHandler == 'vid'
        "
      >
        <img
          class="member-profile"
          :src="profileUrl"
          alt="image"
          loading="lazy"
          v-if="profileUrl"
        />
        <div :class="{ 'visibility-none': detectAvatarFlag }">
          <div v-if="!profileUrl">
            <span v-if="messageSenderName">
              {{ messageSenderName.slice(0, 1).toUpperCase() }}
            </span>
            <span v-else>
              {{ nickname.slice(0, 1).toUpperCase() }}
            </span>
          </div>
        </div>
      </div>
    </div>
    <!-- Message Card Section -->
    <div
      @click.stop="openDropDown($event)"
      class="message-card"
      :dir="rtlDesginHandler ? 'rtl' : 'ltr'"
      :class="{
        'notif-message': notifHandler,
        'current-message-card': senderMessageId == currentUser,
        'light-bg': getCurrentThemeIsDark && senderMessageId == currentUser,
        'dark-mode-color': getCurrentThemeIsDark,
        'sticker-style': messageTypeHandler == 'stk',
      }"
    >
      <div class="reply-container" v-if="handlerForReplyedMessage">
        <div class="name">
          <span v-if="messageSenderName">
            {{ body.data.ext_data.ReplyFromName }}
          </span>
          <span v-else>
            {{ nickname }}
          </span>
        </div>
        <div class="replyed-message-content">
          <img
            v-if="body.data.ext_data.replyFileId"
            :src="replayedImageURL.filePath"
            alt="image"
            style="width: 40px; height: 40px; margin: 5px 0"
          />
          {{ replyedMessageTarget.slice(0, 40) }}
        </div>
      </div>
      <!-- Message type file -->

      <!-- Message type notif -->
      <div
        class="notif-content"
        v-if="messageTypeHandler == 'add'"
        :dir="rtlDesginHandler ? 'rtl' : 'ltr'"
      >
        {{ detectAdminNameInNotifMtype }}
        {{ $t('tabs.message.group.addedtogroup') }}
        <span style="padding: 0 5px">
          {{ lastMemberInNotifMtype }}
        </span>
        {{ handleMessageTime }}
      </div>
      <span class="notif-content" v-if="messageTypeHandler == 'crt'">
        {{ detectAdminNameInNotifMtype }}
        {{ $t('tabs.message.group.createdgroup') }}
        {{ handleMessageTime }}
      </span>
      <span class="notif-content" v-if="messageTypeHandler == 'rmv'">
        {{ detectAdminNameInNotifMtype }}
        {{ $t('tabs.message.group.removed') }}
        <span style="padding: 0 5px">
          {{ lastMemberInNotifMtype }}
        </span>
        {{ handleMessageTime }}
      </span>
      <span class="notif-content" v-if="messageTypeHandler == 'lft'">
        {{ detectAdminNameInNotifMtype }}
        {{ $t('tabs.message.group.leftthegroup') }}
        {{ handleMessageTime }}
      </span>
      <span class="notif-content" v-if="messageTypeHandler == 'cfg.avt'">
        {{ detectAdminNameInNotifMtype }}
        {{ $t('tabs.message.group.changeavatar') }}
        {{ handleMessageTime }}
      </span>
      <span
        class="notif-content"
        v-if="messageTypeHandler == 'cfg.tit'"
        dir="ltr"
      >
        {{ handleMessageTime }}
        <span style="padding: 0 5px">
          {{ newNameGroup }}
        </span>
        <span>
          {{ $t('tabs.message.group.changename') }}
        </span>
        {{ detectAdminNameInNotifMtype }}
      </span>
      <span class="notif-content" v-if="messageTypeHandler == 'jnd'">
        {{ lastMemberInNotifMtype }}
        {{ $t('tabs.message.group.join') }}
        {{ handleMessageTime }}
      </span>
      <!-- Message type notif -->

      <div class="file-message-container" v-if="messageTypeHandler == 'doc'">
        <div class="file-information-container">
          <span class="name">{{ body.data.name }}</span>
          <span class="size" dir="ltr">{{ fileSizeHandler }}</span>
        </div>
        <div class="download-container" @click.stop="handleDownloadFile">
          <ion-spinner
            name="circular"
            color="white"
            style="width: 30px; height: 30px"
            v-if="loading"
          ></ion-spinner>
          <img
            src="/Images/tabs/download-white.svg"
            alt="icon"
            loading="lazy"
            v-else
          />
        </div>
      </div>
      <!-- Message type video -->
      <div class="file-message-container" v-if="messageTypeHandler == 'vid'">
        <div class="file-information-container">
          <span class="name">{{ videoName }}</span>
          <span class="size">{{ fileSizeHandler }}</span>
        </div>
        <div class="download-container" @click.stop="handleDownloadVideo">
          <ion-spinner
            name="circular"
            color="white"
            style="width: 30px; height: 30px"
            v-if="loading"
          ></ion-spinner>
          <img
            class=""
            src="/Images/tabs/download-white.svg"
            alt="icon"
            loading="lazy"
            v-else
          />
        </div>
      </div>
      <!-- Message type voice -->
      <div v-if="messageTypeHandler == 'aud'">
        <audio controls :id="voiceURL">
          <source :src="voiceURL" />
        </audio>
      </div>

      <div style="display: flex; flex-direction: column" v-else>
        <!-- Message type sticker -->
        <coreSkeltonLoading
          width="150px"
          height="150px"
          v-if="loadingStickerFlag && messageTypeHandler == 'stk'"
        />
        <img
          :src="stickerURL.filePath"
          style="width: 150px; height: 150px"
          alt="sticker"
          v-if="!loadingStickerFlag && messageTypeHandler == 'stk'"
          loading="lazy"
        />
        <!-- Message type image -->
        <div v-if="imageURL">
          <img
            v-if="imageURL.itsMain"
            style="width: 220px; height: 220px"
            :src="imageURL.filePath"
            alt="image"
            @click.stop="changeSatusSingleImageMessage"
            loading="lazy"
          />
          <div
            v-else
            style="
              width: 220px;
              height: 220px;
              background-repeat: no-repeat;
              background-size: cover;
              display: flex;
              justify-content: center;
              align-items: center;
            "
            :style="{ 'background-image': 'url(' + imageURL.filePath + ')' }"
          >
            <ion-spinner
              name="circular"
              color="white"
              style="width: 30px; height: 30px"
              v-if="loadingImgFlag"
            ></ion-spinner>
            <div
              @click.stop="downloadImage"
              v-else
              style="
                border: 2px solid #fff;
                border-radius: 50%;
                width: 30px;
                height: 30px;
                display: flex;
                justify-content: center;
                align-items: center;
              "
            >
              <img
                src="/Images/tabs/download-white.svg"
                alt="icon"
                style="width: 20px; height: 20px"
              />
            </div>
          </div>
        </div>
        <!-- Single image view -->
        <div
          class="single-image-message-container"
          @click.stop="console.log('click')"
          v-if="singleImageMessageStatus"
        >
          <div class="single-image-message-container-header">
            <div
              style="
                width: 50%;
                display: flex;
                justify-content: start;
                align-items: center;
              "
            >
              <img
                src="/Images/tabs/arrow-right.svg"
                style="width: 20px; height: 20px"
                alt="icon"
                @click.stop="changeSatusSingleImageMessage"
              />
              <span class="title">
                {{ $t('tabs.message.group.commonMedia') }}
              </span>
            </div>
            <div style="width: 50%; display: flex; justify-content: end">
              <img
                src="/Images/tabs/forword-white.svg"
                alt="icon"
                style="width: 23px; height: 23px"
              />
              <img
                src="/Images/tabs/more-white.svg"
                alt="icon"
                style="width: 25px; height: 25px"
              />
            </div>
          </div>
          <div class="single-image-message-content">
            <img
              style="width: 100%; height: 50vh"
              class="fade-animation"
              :src="imageURL.filePath"
              alt="image"
              loading="lazy"
            />
          </div>
        </div>
        <!-- Message type text -->
        <span class="message" v-if="messageIsEdited">
          {{ messageEditedValue }}
        </span>
        <div class="message" v-if="!messageIsEdited">
          <span v-html="messageValue"></span>
          <span
            v-if="readMoreFlag"
            class="read-more"
            @click.stop="readMoreHandler"
            >{{ $t('tabs.message.readmore') }}</span
          >
        </div>
      </div>

      <div class="time-container" dir="rtl">
        <img
          src="/Images/tabs/message-loading.svg"
          alt="icon"
          v-if="loading"
          loading="lazy"
        />
        <div v-else>
          <div
            v-if="
              messageTypeHandler == 'txt' ||
              messageTypeHandler == 'img' ||
              messageTypeHandler == 'aud' ||
              messageTypeHandler == 'stk' ||
              messageTypeHandler == 'doc' ||
              messageTypeHandler == 'vid'
            "
          >
            <IonIcon
              v-if="seen == 0"
              :class="{
                'display-none': senderMessageId != currentUser,
              }"
              :icon="checkmark"
              size="small"
              color="primary"
            ></IonIcon>
            <IonIcon
              v-if="seen == 1"
              :class="{
                'display-none': senderMessageId != currentUser,
              }"
              color="primary"
              :icon="checkmarkDone"
              size="small"
            ></IonIcon>
          </div>
        </div>
        <span
          v-if="
            messageTypeHandler == 'txt' ||
            messageTypeHandler == 'img' ||
            messageTypeHandler == 'aud' ||
            messageTypeHandler == 'stk' ||
            messageTypeHandler == 'doc' ||
            messageTypeHandler == 'vid'
          "
        >
          {{ handleMessageTime }}
        </span>
        <span v-if="messageIsEdited">Edited</span>
      </div>
      <!-- Drop Down For Handle Replay Edit Delete Forword -->
      <div class="dropdown-container open_animation" v-if="dropDownStatus">
        <div
          class="drop-down"
          :class="{
            'drop-down-current-user': senderMessageId == currentUser,
            'drop-down-other-user': senderMessageId != currentUser,
            'drop-down-dark': getCurrentThemeIsDark,
          }"
          :style="{
            top: ` ${dropDownPosition.y}`,
            left: `${dropDownPosition.x}`,
          }"
        >
          <div class="drop-down-item" @click="handleReplayMessage">
            <img
              src="/Images/tabs/messages/reply.svg"
              alt="icon"
              style="width: 20px; height: 20px"
              loading="lazy"
            />
            <span> {{ $t('tabs.message.replay') }} </span>
          </div>
          <div
            class="drop-down-item"
            v-if="senderMessageId == currentUser"
            @click="handleEditMessage"
          >
            <img
              src="/Images/tabs/pencil-gray.svg"
              alt="icon"
              style="width: 20px; height: 20px"
              loading="lazy"
            />
            <span> {{ $t('tabs.message.edit') }} </span>
          </div>
          <div
            class="drop-down-item"
            v-if="senderMessageId == currentUser"
            @click="handleDeleteMessage"
          >
            <img
              src="/Images/tabs/delete-gray.svg"
              alt="icon"
              style="width: 20px; height: 20px"
              loading="lazy"
            />
            <span> {{ $t('tabs.message.delete') }} </span>
          </div>
        </div>
      </div>
      <!-- Drop Down For Handle Replay Edit Delete Forword -->
    </div>
    <!-- Message Card Section -->
  </div>
</template>

<script setup>
import coreSkeltonLoading from '@/components/coreSkeltonLoading/index.vue';

import { utcToLocalDateConvertor } from '@/helpers/dateAndTimeFormatter.js';
import { renderTextWithAvailableLink } from '@/helpers/textFormatter.js';
import { useFileManagerStore } from '@/store/fileManager/fileManager';
import { getFile, memberMaker } from '@/helpers/parser.js';
import { IonSpinner } from '@ionic/vue';
import { useChatInput } from '@/store/chats/chatInput.js';
import { useGroupChat } from '@/store/chats/groupChat.js';
import { useUserStore } from '@/store/user/user';
import { ref, computed, onMounted } from 'vue';
import { computedAsync } from '@vueuse/core';
import { useI18n } from 'vue-i18n';
import { useThemeStore } from '@/store/theme.js';
import { IonIcon } from '@ionic/vue';
import { checkmark, checkmarkDone } from 'ionicons/icons';

const { locale } = useI18n();
const userStore = useUserStore();
const fileManagerStore = useFileManagerStore();
const groupChatStore = useGroupChat();
const chatInputstore = useChatInput();
const themeStore = useThemeStore();
const dropDownStatus = ref(false);
const loadingImgFlag = ref(false);
const loadingStickerFlag = ref(false);
const singleImageMessageStatus = ref(false);
const voiceURL = ref('');
const imageURL = ref('');
const replayedImageURL = ref('');
const stickerURL = ref('');
const fileURL = ref('');
const videoURL = ref('');
const profileUrl = ref('');
const dropDownPosition = ref({
  x: '0',
  y: '0',
});
const detectAvatarFlag = ref(null);
const readMoreFlag = ref(false);
const messageValue = ref('');
const lastMemberInNotifMtype = ref('');

const props = defineProps({
  messageSenderName: {
    type: String,
    default: '',
  },
  senderMessageId: {
    type: String,
    default: '',
  },
  senderMessagePhoneNumber: {
    type: String,
    default: '',
  },
  firstChar: {
    type: String,
    default: '',
  },
  mtype: {
    type: String,
    default: '',
  },
  messageId: {
    type: String,
    default: '',
  },
  message: {
    type: String,
    default: '',
  },
  time: {
    type: String,
    default: '',
  },
  groupName: {
    type: String,
    default: '',
  },
  body: {
    type: Object,
    default: {},
  },
  loading: {
    type: Boolean,
    default: false,
  },
  avatar: {
    type: String,
    default: '',
  },
  nickname: {
    type: String,
    default: '',
  },
  seen: {
    type: Number,
    default: 0,
  },
  avatarFlag: {
    type: Boolean,
    default: false,
  },
});

const detectAdminNameInNotifMtype = computed(() => {
  if (props.messageSenderName) {
    return props.messageSenderName;
  } else {
    return props.nickname;
  }
});

const newNameGroup = computed(() => {
  if (props.body.data.value) {
    return props.body.data.value;
  }
});

const videoName = computed(() => {
  if (props.body.data.name.length > 12) {
    return `${props.body.data.name.slice(0, 20)}...`;
  } else {
    return props.body.data.name;
  }
});

const messageTypeHandler = computed(() => {
  const mtype = props.mtype.slice(4);
  return mtype;
});

const notifHandler = computed(() => {
  switch (messageTypeHandler.value) {
    case 'add':
      return true;
      break;
    case 'crt':
      return true;
      break;
    case 'lft':
      return true;
      break;
    case 'jnd':
      return true;
      break;
    case 'rmv':
      return true;
      break;
    case 'cfg.tit':
      return true;
      break;
    case 'cfg.avt':
      return true;
      break;
  }
});

const formatBytes = (bytes, decimals = 2) => {
  if (!+bytes) return '0 Bytes';
  const k = 1024;
  const dm = decimals < 0 ? 0 : decimals;
  const sizes = [
    'Bytes',
    ' KB',
    ' MB',
    'GiB',
    'TiB',
    'PiB',
    'EiB',
    'ZiB',
    'YiB',
  ];
  const i = Math.floor(Math.log(bytes) / Math.log(k));
  return `${parseFloat((bytes / Math.pow(k, i)).toFixed(dm))} ${sizes[i]}`;
};

const readMoreHandler = () => {
  readMoreFlag.value = false;
  const convertToLink = renderTextWithAvailableLink(props.message);
  messageValue.value = convertToLink;
};

const downloadImage = async () => {
  loadingImgFlag.value = true;
  setTimeout(async () => {
    const downloadImageFile = await fileManagerStore.handlerForGettingFile(
      props.body.data.fileId,
      'image',
      false,
    );
    imageURL.value = downloadImageFile;
    loadingImgFlag.value = false;
  }, 500);
};

const fileSizeHandler = computed(() => {
  const fileSize = formatBytes(props.body.data.size);
  return fileSize;
});

const getCurrentThemeIsDark = computed(() => {
  return themeStore.getThemeIsDark;
});

const currentUser = computed(() => {
  return userStore.userId;
});

const handleMessageTime = computed(() => {
  if (props.time) {
    const time = utcToLocalDateConvertor(props.time);
    const result = time.toString().slice(15, 21);
    return result;
  }
});

const handlerForReplyedMessage = computed(() => {
  if (props.body.data.ext_data) {
    if (props.body.data.ext_data.replyType) {
      return true;
    } else {
      return false;
    }
  } else {
    return false;
  }
});

const messageIsEdited = computed(() => {
  if (props.body.edit_state) {
    return true;
  } else {
    return false;
  }
});

const messageEditedValue = computed(() => {
  if (props.body.message) {
    return props.body.message;
  }
});

const replyedMessageTarget = computed(() => {
  return props.body.data.ext_data.replyDescription;
});

const rtlDesginHandler = computed(() => {
  {
    if (locale.value == 'fa') {
      return true;
    } else {
      return false;
    }
  }
});

const handleDownloadFile = async () => {
  const downloadFile = await getFile(
    props.body.data.fileId,
    userStore.token,
    'file',
  );
  fileURL.value = downloadFile.filePath;
  const link = document.createElement('a');
  link.href = fileURL.value;
  link.download = fileURL.value;
  link.click();
};

const handleDownloadVideo = async () => {
  const downloadVideo = await getFile(
    props.body.data.fileId,
    userStore.token,
    'video',
  );
  videoURL.value = downloadVideo.filePath;
  const link = document.createElement('a');
  link.href = videoURL.value;
  link.download = videoURL.value;
  link.click();
};

const changeSatusSingleImageMessage = () => {
  singleImageMessageStatus.value = !singleImageMessageStatus.value;
};

const openDropDown = (event) => {
  if (props.loading) {
    dropDownStatus.value = false;
  } else {
    dropDownStatus.value = !dropDownStatus.value;
    dropDownPosition.value.x = `${100}px`;
    dropDownPosition.value.y = `${event.y}px`;
  }
};

const handleReplayMessage = () => {
  let result = {};
  if (props.mtype == 'grp.img') {
    result = { ...props, blob: imageURL.value };
  } else if (props.mtype == 'grp.stk') {
    result = { ...props, blob: stickerURL.value };
  } else {
    result = { ...props, blob: '' };
  }
  chatInputstore.updateMessageSenderInformation({
    ...result,
  });
  chatInputstore.handleUpdateSendMessageFlag('replay');
};

const handleEditMessage = () => {
  chatInputstore.updateMessageSenderInformation({ ...props, blob: '' });
  if (props.body.edit_state == 0) {
    const message = props.message;
    chatInputstore.handleUpdateChatInputValue(message);
  } else {
    const message = props.body.message;
    chatInputstore.handleUpdateChatInputValue(message);
  }
  chatInputstore.handleUpdateSendMessageFlag('edit');
};

const handleDeleteMessage = () => {
  const param = {
    groupId: groupChatStore.currentGroup.group_id,
    guid: props.messageId,
    message: props.message,
    title: props.messageSenderName,
  };
  groupChatStore.deletedMessage(param);
};

onMounted(async () => {
  if (props.body.data.uuid) {
    const targetMember = await memberMaker(props.body.data.uuid);
    if (targetMember.name) {
      lastMemberInNotifMtype.value = targetMember.name;
    } else {
      lastMemberInNotifMtype.value = targetMember.nickname;
    }
  }

  if (props.message.length > 600) {
    readMoreFlag.value = true;
    const msg = props.message.slice(0, 600) + '...';
    const convertToLink = renderTextWithAvailableLink(msg);
    messageValue.value = convertToLink;
  } else {
    readMoreFlag.value = false;
    const convertToLink = renderTextWithAvailableLink(props.message);
    messageValue.value = convertToLink;
  }

  if (props.avatar) {
    const fileId = props.avatar.split('.');
    const fileIdResult = fileId[0] ? fileId[0] : props.avatar;
    const blob = await getFile(fileIdResult, userStore.token, 'image');
    profileUrl.value = blob.filePath;
  }

  if (props.body.data.ext_data) {
    if (props.body.data.ext_data.replyFileId) {
      const downloadReplayedImage =
        await fileManagerStore.handlerForGettingFile(
          props.body.data.ext_data.replyFileId,
          'thumbnail',
          true,
        );
      replayedImageURL.value = downloadReplayedImage;
    }
  }

  const targetMessage = groupChatStore.currentGroup.messages.find((message) => {
    return message.guid == props.messageId;
  });
  const detectIndex =
    groupChatStore.currentGroup.messages.lastIndexOf(targetMessage);
  const nextMessage = groupChatStore.currentGroup.messages[detectIndex + 1];

  detectAvatarFlag.value = props.avatarFlag;

  if (nextMessage) {
    if (nextMessage.from == props.senderMessageId) {
      detectAvatarFlag.value = true;
    } else {
      detectAvatarFlag.value = false;
    }
  } else {
    detectAvatarFlag.value = false;
  }

  switch (props.body.mtype) {
    case 'grp.aud':
      const downloadVoiceFile = await getFile(
        props.body.data.fileId,
        userStore.token,
        'audio',
      );
      voiceURL.value = downloadVoiceFile.filePath;
      setTimeout(() => {
        const audio = document.getElementById(voiceURL.value);
        audio.src = voiceURL.value;
      }, 200);
      break;

    case 'grp.img':
      const downloadImageFile = await fileManagerStore.handlerForGettingFile(
        props.body.data.fileId,
        'thumbnail',
        true,
      );
      imageURL.value = downloadImageFile;
      break;

    case 'grp.stk':
      loadingStickerFlag.value = true;
      const downloadStikcer = await fileManagerStore.handlerForGettingFile(
        props.body.data.fileId,
        'image',
        false,
      );
      stickerURL.value = downloadStikcer;
      loadingStickerFlag.value = false;
      break;
  }

  if (props.senderMessageId != userStore.userId && props.seen == 0) {
    const result = {
      ...props,
      groupId: groupChatStore.currentGroup.group_id,
    };
    await groupChatStore.seenedMessage(result);
  }
});
</script>

<style scoped>
.visibility-none {
  visibility: hidden;
}

.read-more {
  color: blueviolet;
  font-size: 14px;
}
.single-image-message-container {
  width: 100%;
  height: 100vh;
  position: fixed;
  z-index: 1;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  background: #303030;
  display: flex;
  flex-direction: column;
  overflow: hidden;
}
.single-image-message-container-header {
  width: 100%;
  height: 10vh;
  display: flex;
  justify-content: center;
  align-items: center;
  padding: 0 15px;
}

.single-image-message-container-header .title {
  color: #fff;
  font-family: Yekan Bakh FaNum;
  font-size: 20px;
  font-style: normal;
  font-weight: 700;
  line-height: normal;
  padding: 0 15px;
}

.single-image-message-content {
  width: 100%;
  height: 80vh;
  display: flex;
  justify-content: center;
  align-items: center;
}
.dropdown-container {
  width: 100%;
  height: 100vh;
  position: fixed;
  z-index: 1;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  background: rgba(158, 155, 155, 0);
  display: flex;
  justify-content: center;
  align-items: center;
  overflow: hidden;
}

.file-message-container {
  height: 70px;
  display: flex;
  justify-content: center;
  align-items: center;
}

.file-information-container {
  display: flex;
  flex-direction: column;
  align-items: end;
  justify-content: center;
}

.file-information-container .name {
  font-size: 14px;
  font-style: normal;
  font-weight: 700;
  line-height: normal;
  padding: 0 10px;
}

.file-information-container .size {
  font-size: 12px;
  font-weight: 500;
  color: gray;
  padding: 0 10px;
}

.download-container {
  width: 45px;
  height: 45px;
  border-radius: 50%;
  background: #428cff;
  display: flex;
  justify-content: center;
  align-items: center;
}

audio {
  width: 260px;
}

ion-spinner {
  width: 10px;
  height: 10px;
}
.message-card-container {
  display: flex;
  padding: 5px 10px;
}

.avatar-container {
  display: flex;
  align-items: end;
}

.notif-message-container {
  display: flex !important;
  justify-content: center !important;
  width: 100% !important;
  color: #151215;
}
.notif-message {
  display: flex;
  justify-content: center;
  border-radius: 20px !important;
  background: #fff !important;
  width: 100%;
}

.notif-content {
  font-size: 12px;
  font-weight: 700;
  display: flex;
}

.avatar-container .avatar {
  width: 40px;
  height: 40px;
  border-radius: 50%;
  background: #6d55da;
  display: flex;
  justify-content: center;
  align-items: center;
  color: #fff;
  font-size: 18px;
  font-weight: 600;
}

.member-profile {
  width: 40px;
  height: 40px;
  border-radius: 50%;
}
.message-card {
  position: relative;
  width: auto;
  display: flex;
  flex-direction: column;
  background: #fff;
  color: #202020;
  padding: 5px 10px;
  margin: 0 10px;
  border-radius: 15px 15px 15px 0;
  max-width: 80%;
}

.drop-down {
  width: 130px;
  display: flex;
  flex-direction: column;
  position: absolute;
  z-index: 1;
  background: #fff;
  border-radius: 5px;
  padding: 10px 15px;
}

.drop-down-dark {
  background: #202020;
  color: #fff;
}

.drop-down-current-user {
  margin-right: 30px;
}

.drop-down-other-user {
  margin-right: -120px;
}

.drop-down .drop-down-item {
  display: flex;
  margin: 8px 0;
}

.drop-down-item span {
  font-size: 16px;
  font-style: normal;
  font-weight: 700;
  line-height: normal;
  padding: 0 15px;
}

.message-card .message {
  font-size: 14px;
  font-style: normal;
  font-weight: 700;
  line-height: normal;
  padding-top: 6px;
}

.time-container {
  width: 100%;
  display: flex;
  align-items: center;
}

.time-container span {
  font-size: 10px;
  font-style: normal;
  font-weight: 700;
  line-height: normal;
  color: #a8a3a3;
  padding: 0px 5px;
  padding-top: 7px;
}

.reply-container {
  border-radius: 4px;
  background: rgba(0, 102, 255, 0.1);
  border-left: 3px solid #6d55da;
  display: flex;
  flex-direction: column;
  padding: 5px 5px;
  margin-top: 5px;
}

.reply-container .name {
  font-size: 14px;
  font-weight: 700;
  color: #6d55da;
}

.reply-container .replyed-message-content {
  color: #a1a0a0;
  font-size: 12px;
  font-weight: 600;
}

.current-user {
  display: flex;
  justify-content: start;
  direction: rtl;
}

.current-message-card {
  background: #c5ffb6;
  color: #202020;
  border-radius: 15px 15px 0 15px;
}

.dark-mode-bg {
  background: #333333;
}

.light-bg {
  background: #c5ffb6;
}

.sticker-style {
  background: none;
}

.display-none {
  display: none;
}
</style>
